""" Debian Linux Backend

Please note that this backend is NOT complete at this time, and exists
solely so I could test the multiple backend mechanism. (I've never admin'd a
debian box, and so would be a poor choice to implement it.  I'm taking
patches...

See redhat.py for a fully implemented backend.

See backend.py for documentation for all the API calls.
   
"""

# import dpkg   I hope somebody wrote this.
import os
import os.path
import string


def HostMatch():
    if os.path.isfile("/etc/debian_version"):
        return 1
    else:
        return 0


class Backend:
    """ For proper documentation, see the base module backend.py. """
    
    def __init__(self):
        
        # I imagine you'd open the dpkg db here...
        
        # I have no idea how to get the debian release # - on RH, you 
        # can query for the "redhat-release" pkg...
        self._release = ""

        # Linux is linux, so this code should be the same as RH's...
        # get the arch
        f = os.popen("/bin/uname -m", "r")
        result = string.strip(f.readline())
        f.close()

        # uname reports the exact arch - i686, i586, usparc. We really want
        #   the arch "family" that the host belongs to.
        self._arch = self._get_arch_family(result)
                        
        
    def __del__(self):
        pass
        
        
    def get_os_release(self):
        return self._release 


    def get_host_arch(self):
        return self._arch   
        
        
    def is_pkg_installed(self, pkg):
        # no earthly clue
        return 0


    def _get_arch_family(self, arch):
        # I wish there were a more efficient, less maintenence prone way to
        # do this, but I can't think of one.
        
        # The code for this was tortured from wallace's
        # pkgDB._getCompatRepositoryList()
        
        # family on the left, members of that family on the right.
        # dict needs to contain any string "uname -m" can return. 
        repcompat = {}
        repcompat['i386'] = ['athlon', 'i686', 'i586', 'i486', 'i386' ]
        repcompat['sparc'] = [ 'usparc', 'sparc64', 'sparc' ]
        repcompat['alpha'] = [ 'alphaev67', 'alphaev6', 'alphapca56', 'alphaev5',
                               'alphaev5', 'alpha', 'axp' ]
        repcompat['ppc'] = [ 'ppc' ]
        
        for family in repcompat.keys():
            if arch in repcompat[family]:
                return family
                
        return ""


## END OF LINE ##
