""" Random library of functions

This modules just defines some helper stuff that didn't belong anywhere
else.

"""

import md5
import string


def Md5File(filename):
    """ Get the md5 sum of a filename  """

    # Boldly stolen from up2date.py
    hash = md5.new()
    
    try:
        f = open(filename, "r")
    except:
        return ""

    # This might be a problem for really big files. Since this is mostly
    # for config files, not a problem. (I stole this code from up2date, 
    # which I would have thought would encounter a performance problem)
    fData = f.read()
    hash.update(fData)
    del fData
    f.close()
    
    hex = string.hexdigits
    md5sum = ""
    
    for c in hash.digest():
        i = ord(c)
        md5sum = md5sum + hex[(i >> 4) & 0xF] + hex[i & 0xf]

    return md5sum


def PathJoin(*components):
    """ Join some path sections together.
    
    This should not be necessary, but os.path.join() does NOT do what we
    want.

    """
    
    ret = components[0]
    components = components[1:]
    for path in components:
        if ret[-1] == "/" and path[0] == "/":
            ret = ret + path[1:]
        elif ret[-1] != "/" and path[0] != "/":
            ret = ret + "/" + path
        else:
            ret = ret + path
    return ret


### END OF LINE ###
